package de.dhbw.unit;

import de.dhbw.contactdb.Main;
import de.dhbw.contactdb.ProjektTester;
import de.dhbw.contactdb.utils.Parser;
import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.Test;

import java.util.stream.Collectors;

import static org.junit.jupiter.api.Assertions.*;

public class ProjectTest {
    @BeforeAll
    public static void before() {
        Parser.parse("/de/dhbw/contactdb/db/contacts2021.db");
    }

    @Test
    public void testSearchPerson() {
        assertEquals("Mila Milan ", Main.searchForPerson("ila"));
    }

    @Test
    public void testSearchPlace() {
        assertEquals("Supermarkt GroÃŸmarkt ", Main.searchForPlace("markt"));
    }

    @Test
    public void testContactPersons() {
        assertEquals("Ben, Carla, Emilia, Emily, Joshua, Malia, Maria, Mia, Sophia", Main.getContactPersons(158).stream()
                .filter(visit -> visit.getPerson().getId() != 158)
                .map(visit -> visit.getPerson().getName())
                .sorted()
                .distinct()
                .collect(Collectors.joining(", ")));
    }

    @Test
    public void testVisitors() {
        assertEquals("Anna, Charlotte, Emilia, Leonie, Marie, Mia", Main.getVisitors("=3,\"2021-05-15T11:00:00\"").stream()
                .map(visit -> visit.getPerson().getName())
                .sorted()
                .distinct()
                .collect(Collectors.joining(", ")));
    }

    @Test
    public void testImport() {
        assertNotNull(Main.class.getResourceAsStream("/de/dhbw/contactdb/db/contacts2021.db"));
    }
}